USE TEMPDB
GO

CREATE TABLE Products  (
	[ProductID] [int] NOT NULL,
	[Name] [nvarchar](100) NOT NULL,
	[ProductNumber] [nvarchar](25) NOT NULL,
	[Colour] [nvarchar](15) NULL )
GO

-- SQL 2000/2005 methods
INSERT INTO Products  (	[ProductID], [Name], 	[ProductNumber],	[Colour] )
SELECT  991, 'Mountain-500 Black, 44', 'BK-M18B-44', 'Black'
UNION ALL SELECT 992, 'Mountain-500 Black, 48', 'BK-M18B-48', 'Black'
UNION ALL SELECT 993, 'Mountain-500 Black, 52', 'BK-M18B-52', 'Black'
GO

-- Using Row Constructors
INSERT INTO Products  (	[ProductID], [Name], 	[ProductNumber],	[Colour] )
VALUES 
( 997, 'Road-750 Black, 44', 'BK-R19B-44', 'Black'),
( 998, 'Road-750 Black, 48', 'BK-R19B-48', 'Black'),
( 999, 'Road-750 Black, 52', 'BK-R19B-52', 'Black')
GO

INSERT INTO Products  (	[ProductID], [Name], 	[ProductNumber],	[Colour] )
SELECT [ProductID], [Name], 	[ProductNo],	[Colour]
FROM ( VALUES 
( 1000, 'City Bike-3000 Red, 44', 'CB-T30U-44', 'Red'),
( 1001, 'City Bike-4000 Red, 50', 'BK-T40U-50', 'Red'),
( 1001, 'City Bike-4000 Red, 50', 'BK-T40U-50', 'Red')
) ld ( [ProductID], [Name], 	[ProductNo],	[Colour]  )
GO

-- Make sure Grid Mode is on!
SELECT [ProductID], [Name], [ProductNumber], [Colour] FROM Products
GO

-- Clean Up
DROP TABLE Products 
GO