USE TEMPDB
GO

SET NOCOUNT ON
GO

CREATE TABLE Survey
(SurveyID int NOT NULL identity CONSTRAINT PK_Survey PRIMARY KEY,
Name varchar(200) NOT NULL,
Age int NULL,
bought_fruit char(1) SPARSE NULL,
bought_dairy char(1) SPARSE NULL,
bought_bakery char(1) SPARSE NULL,
bought_wine char(1) SPARSE NULL,
Results XML COLUMN_SET FOR ALL_SPARSE_COLUMNS);
GO

-- Using Row Constructors!!
INSERT INTO Survey ( Name, Age, bought_fruit, bought_dairy, bought_bakery, bought_wine )
VALUES ( 'Preston Burke', 45, 'Y', NULL, 'N', 'Y' ),
( 'Cristina Yang', 24, 'Y', NULL, 'Y', 'Y' ),
( 'Erica Hahn', 40, 'Y', 'Y',NULL, 'Y' )
GO


SELECT Name, Age, bought_fruit, bought_dairy, bought_bakery, bought_wine
FROM Survey

-- Insert using column set
INSERT INTO Survey ( Name, Age, Results )
VALUES ( 'Richard Webber', 54, '<bought_dairy>Y</bought_dairy><bought_fruit>Y</bought_fruit><bought_bakery>Y</bought_bakery><bought_wine>N</bought_wine>'),
(  'Miranda Bailey', 42, '<bought_dairy>Y</bought_dairy><bought_bakery>Y</bought_bakery>'),
(  'Meredith Grey', 25, '<bought_wine>Y</bought_wine>')
GO

SELECT * FROM Survey

-- Same As
SELECT Name, Age, Results FROM Survey

SELECT Name, Age, bought_fruit, bought_dairy, bought_bakery, bought_wine, Results 
FROM Survey
GO

-- Update using Column Set
UPDATE Survey 
SET Results =  '<bought_bakery>Y</bought_bakery><bought_wine>Y</bought_wine>'
WHERE name = 'Meredith Grey'
GO

SELECT Name, Age, bought_fruit, bought_dairy, bought_bakery, bought_wine
FROM Survey
GO

-- Update using Column Set (columns not included will be set to null)
UPDATE Survey 
SET Results =  '<bought_wine>N</bought_wine>'
WHERE name = 'Meredith Grey'
GO

UPDATE Survey 
SET bought_dairy =  'Y'
WHERE name = 'Meredith Grey'
GO

SELECT Name, Age, bought_fruit, bought_dairy, bought_bakery, bought_wine
FROM Survey
GO

-- Clean Up
DROP TABLE Survey
GO

