USE TEMPDB
GO

SET NOCOUNT ON
GO

-- New Table Type
-- Can't  function for derived column
CREATE TYPE udt_HospitalHierarchy AS TABLE ( hid HierarchyId NOT NULL PRIMARY KEY CLUSTERED,
						name varchar(30) not null,
						[type] char(10) not null
						)
GO

-- Table parameter has to be read only
CREATE PROCEDURE Get_Residents_From_Table ( @h udt_HospitalHierarchy READONLY )
AS
		SELECT hid.ToString() AS node,
						hid.GetLevel() AS [level],
						name,
						[type]
		FROM @h
		WHERE [type]  = 'Resident'
GO

-- Set Grid mode
DECLARE @h1 udt_HospitalHierarchy

INSERT @h1 ( hid, name, type)
VALUES ( hierarchyid::GetRoot(),
		'Seatle Grace Hospital',
		'Hospital' )

DECLARE @RootNode hierarchyid 
SELECT @RootNode = hierarchyid::GetRoot()
INSERT @h1 ( hid, name, type )
VALUES ( @RootNode.GetDescendant(NULL, NULL), 
		'Cardiology',
		'Department' )

INSERT @h1 ( hid, name, type )
SELECT  (SELECT hid FROM @h1 WHERE name = 'Cardiology').GetDescendant( NULL, NULL), 
				'Preston Burke',
				'Consultant' 

INSERT @h1 ( hid, name, type )
SELECT  (SELECT hid FROM @h1 WHERE name = 'Cardiology').GetDescendant( (SELECT MAX(c.hid) FROM @h1 p JOIN @h1 c ON p.hid.IsDescendant(c.hid) = 1 AND  p.name = 'Cardiology'), NULL), 
				'Cristina Yang',
				'Resident' 

INSERT @h1 ( hid, name, type )
SELECT  (SELECT hid FROM @h1 WHERE name = 'Cardiology').GetDescendant( (SELECT MAX(c.hid) FROM @h1 p JOIN @h1 c ON p.hid.IsDescendant(c.hid) = 1 AND  p.name = 'Cardiology'), NULL), 
				'Erica Hahn ',
				'Consultant' 

SELECT hid.ToString() AS node,
						hid.GetLevel() AS [level],
						name,
						[type]
FROM @h1

EXEC Get_Residents_From_Table @h1
GO

-- A different table
DECLARE @h2 udt_HospitalHierarchy

INSERT @h2 ( hid, name, type)
VALUES ( hierarchyid::GetRoot(),
		'Seatle Grace Hospital',
		'Hospital' )

DECLARE @RootNode hierarchyid 
SELECT @RootNode = hierarchyid::GetRoot()
INSERT @h2 ( hid, name, type )
VALUES ( @RootNode.GetDescendant(NULL, NULL), 
		'General Surgery',
		'Department' )

INSERT @h2 ( hid, name, type )
SELECT  (SELECT hid FROM @h2 WHERE name = 'General Surgery').GetDescendant( NULL, NULL), 
				'Richard Webber',
				'Consultant' 

INSERT @h2 ( hid, name, type )
SELECT  (SELECT hid FROM @h2 WHERE name = 'General Surgery').GetDescendant( (SELECT MAX(c.hid) FROM @h2 p JOIN @h2 c ON p.hid.IsDescendant(c.hid) = 1 AND  p.name = 'General Surgery'), NULL), 
				'Miranda Bailey',
				'Consultant'

INSERT @h2 ( hid, name, type )
SELECT  (SELECT hid FROM @h2 WHERE name = 'General Surgery').GetDescendant( (SELECT MAX(c.hid) FROM @h2 p JOIN @h2 c ON p.hid.IsDescendant(c.hid) = 1 AND  p.name = 'General Surgery'), NULL), 
				'Meredith Grey ',
				'Resident'

SELECT hid.ToString() AS node,
						hid.GetLevel() AS [level],
						name,
						[type]
FROM @h2

EXEC Get_Residents_From_Table @h2
GO

